<?php

require_once "../libs/vendor/autoload.php";

class reporteCierrePDF
{
    // * Variables globales para mPDF
    public $mpdf;
    public $htmlFile;
    public $renderHTML;

    // * Variables globales para SendGrid
    public $email;
    // Subrutina para generar el reporte con los datos del $response[]
    public function generarReporteCierrePDF($params)
    {
        // ! Establece la zona horaria por defecto.
        date_default_timezone_set('America/Guatemala');

        // ! Creación de fecha y hora
        $fechaHora = date("Y-m-d-H-i-s");

        // ! Ajuste de parametros
        // * Matriz $detalleVentas para recorrer
        $detalleVentas = $params['detalleVentas'];
        // * Variables a asignar el Detalle de Venta
        $codC = "";
        $nombreC = "";
        $desc = "";
        $total = "";
    	$grupo = "";
    	$descripcion = "";
    
    	$totalCable = $params['totalCable'];
    	$totalInternet = $params['totalInternet'];
    	$totalAdicional = $params['totalAdicional'];

        foreach ($detalleVentas as $index => $value) {
            if (is_array($value)) {
                foreach ($value as $key => $values) {
                    echo $key . " : " . $values . "<br>";
                
                	if ($key == "idGrupos") {
                    	 $grupo = $values;
                    }
                
                    if ($key == "codigoC") {
                        $codC .= $values  . '<br>';
                    }
                    if ($key == "nombreC") {
                        $nombreC .= $values  . '<br>';
                    }
                    if ($key == "nombre") {
                        $desc .= $values  . '<br>';
                    }
                	if ($key == "descripcion") {
                        $descripcion .= $values  . '<br>';
                    }
                    if ($key == "total") {
                        $total .= "Q " . $values  . '<br>';

                    }
                	
                }
            }
        }
    
    
        // $keys = array_keys($detalleVentas);
        // for ($i = 0; $i < count($detalleVentas); $i++) {
        //     echo $keys[$i] . "<br>";

        //     foreach ($detalleVentas[$keys[$i]] as $key => $value) {
        //         echo $key . " : " . $value . "<br>";
        //     }
        // }

        // * Valida si hay diferencia

        if ($params['diferencia'] == "0.00" || $params['diferencia'] == "") {
            $diferencia = "";
        } else {
            $diferencia = "<p style='text-align: center'>DIFERENCIA: Q " . $params['diferencia'] . "</p>";
        }

        // ! MPDF
        // * Crea una instancia de la clase Mpdf:
        $this->mpdf = new \Mpdf\Mpdf();

        // * Renderizado del html.
        $this->renderHTML = "
            <!DOCTYPE html>
            <html lang='es'>
                <head>
                    <meta charset='UTF-8' />
                    <meta name='viewport' content='width=device-width, initial-scale=1.0' />
                    <!-- Compiled and minified CSS -->
                    <link
                        rel='stylesheet'
                        href='https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css'
                    />            
                    <title>Reporte Cierre</title>
                </head>
            
                <body>
                    <div class='container'>
                        <div class='row'>
                            <div class='col l12'>
                                <h4 style='text-align: center'>CORTE CAJA</h4>
                                <h4 style='text-align: center'>" . $params['nombreEmpresa'] . "</h4>
                                <h5>Usuario: " . $params['nombreUsuario'] . "</h5>
                                <h6>APERTURA: " . $params['fecIniFondo'] . "</h6>
                                <h6>CIERRE: " . $params['fecFinFondo'] . "</h6>
                                <!-- <h5>VALES: Q " . $params['totalVales'] . "</h5> -->
                                <h5>FONDO CAJA: Q " . $params['montoFondo'] . "</h5>
                                <h5>VISA: Q " . $params['totalVisa'] . "</h5>
                                <!--<h5>CREDOMATIC: Q " . $params['totalBac'] . "</h5>-->
                                <h5>EFECTIVO: Q " . $params['totalEfectivoQ'] . "</h5>
                                <!--<h5>DESCUENTOS: Q " . $params['totalDescuento'] . "</h5>-->
                                <!--<h4>VENTA NETA: Q " . $params['totalVentas'] . "</h4>-->
                                <h4>COBRO TOTAL: Q " . $params['totalVentas'] . "</h4>
                                <!--<h5>DIFERENCIA: Q " . $params['diferencia'] . "</h5>-->

                            </div>
                        </div>
                        <div class='row'>
                            <div class='col l12'>
                                <p style='text-align: center'>- DETALLE POR CLIENTE -</p>
                                <p></p>
                                <table class='responsive-table striped' style='border: 1px solid black'>
                                    <thead>
                                        <tr>
                                            <th style='width=10%; border: 1px solid black'>
                                                Descripcion 
                                            </th>
                                            <th style='width=10%; border: 1px solid black'>
                                                SKU 
                                            </th>
                                            <th style='width=10%; border: 1px solid black'>
                                                Cant. 
                                            </th>
                                            <th style='width=10%; border: 1px solid black'>
                                                Descuento 
                                            </th>
                                            <th style='width=10%; border: 1px solid black'>
                                                Total 
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td style='width=10%; border: 1px solid black'>
                                                " . $nombre . "<br>
                                            </td>
                                            <td style='width=10%; border: 1px solid black'>
                                                " . $sku . "<br>
                                            </td>
                                            <td style='width=10%; border: 1px solid black'>
                                                " . $cant . "<br>
                                            </td>
                                            <td style='width=10%; border: 1px solid black'>
                                                " . $desc . "<br>
                                            </td>
                                            <td style='width=10%; border: 1px solid black'>
                                                " . $total . "<br>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </body>
            </html>
        ";

        $this->renderHTML_test = "
            <!DOCTYPE html>
            <html lang='es'>
                <head>
                    <meta charset='UTF-8' />
                    <meta name='viewport' content='width=device-width, initial-scale=1.0' />
                    <style>       
                    body {
                        font-family: Calibri, sans-serif;
                    }
                    </style>
                    <title>Reporte Cierre</title>
                </head>
            
                <body>
                    <div>
                        <div>
                            <div>
                                <div>
                                    <h1 style='text-align: center'>Corte de caja</h1>
                                    <h2 style='text-align: center'>" . $params['nombreEmpresa'] . "</h2>
                                </div>
                                <div>
                                    <p style='margin-bottom: 0px; padding-bottom: 0px; text-align: center; font-size: 14rpx'>Usuario: " . $params['nombreUsuario'] . "</p>
                                    <p style='margin-bottom: 0px; padding-bottom: 0px; text-align: center; font-size: 12rpx'>APERTURA: " . $params['fecIniFondo'] . "</p>
                                    <p style='text-align: center; font-size: 12rpx'>CIERRE: " . $params['fecFinFondo'] . "</p>
                                </div>                             
                                <div style='margin: 0% 0% 0% 35%; width: 40%;'>
                                    <table>
                                        <tr>
                                            <td>FONDO CAJA: </td>
                                            <td>Q " . $params['montoFondo'] . "</td>               
                                        </tr>
                                        <!--<tr>
                                            <td>VALES: </td>
                                            <td>Q " . $params['totalVales'] . "</td>               
                                        </tr>-->
                                        <tr>
                                            <td>VISA: </td>
                                            <td>Q " . $params['totalVisa'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>CHEQUES: </td>
                                            <td>Q " . $params['totalCheques'] . "</td>               
                                        </tr>
                                        <!--<tr>
                                            <td>CREDOMATIC: </td>
                                            <td>Q " . $params['totalBac'] . "</td>               
                                        </tr>-->
                                        <tr>
                                            <td>EFECTIVO: </td>
                                            <td>Q " . $params['totalEfectivoQ'] . "</td>               
                                        </tr>
                                        <!--<tr>
                                            <td>DESCUENTOS: </td>
                                            <td>Q " . $params['totalDescuento'] . "</td>               
                                        </tr>-->
                                    </table>
                                </div>
                                <div>
                                    <h2 style='text-align: center'>COBRO TOTAL: Q " . $params['totalVentas'] . "</h2>

                                </div>
                            </div>
                        </div>
                        <div>
                            <div>
                                <div>
                                    <h3 style='text-align: center'>- DETALLE POR CLIENTE -</h3>
                                </div>
                                <div style='margin: 0% 0% 0% 0%; width: 117%;'>                                
                                    <table style='font-size: 12px;'>
                                        <tr>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 20%;'>
                                                <b>CÓDIGO CLIENTE</b>
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 65%;'>
                                                <b>NOMBRE CLIENTE</b> 
                                            </th>                                            
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 16%;'>
                                                <b>DESCRIPCIÓN</b> 
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 16%;'>
                                                <b>TIPO SERVICIO</b> 
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                                <b>TOTAL</b> 
                                            </th>
                                        </tr>
                                        <tr>
                                            <td style='padding-right: 10px; padding-left: 0px; text-align: right;'>
                                                " . $codC . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 10px; text-align: left;'>
                                                " . $nombreC . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: left;'>
                                                " . $desc . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: left;'>
                                                " . $descripcion . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                " . $total . " <br>
                                            </td>
                                        </tr>
                                    </table>
                                     <div style='margin: 10% 0% 0% 35%; width: 40%;'>
                                    	<table>
                                        	<tr>
                                            	<td>TOTAL CABLE: </td>
                                            	<td>Q " . $totalCable. "</td>               
                                        	</tr>
                                            <tr>
                                            	<td>TOTAL INTERNET: </td>
                                            	<td>Q " . $totalInternet . "</td>               
                                        	</tr>
                                            <tr>
                                            	<td>TOTAL CARGOS ADICIONALES: </td>
                                            	<td>Q " . $totalAdicional . "</td>               
                                        	</tr>
                                        </table>
                                	</div>
                                </div>
                            </div>
                        </div>
                    </div>
                </body>
            </html>
        ";

        // * Renderiza el HTML
        $this->mpdf->WriteHTML($this->renderHTML_test);

        // * Genera nombre del pdf
        $nombrePdf = "reporte_cierre_" . $params['nombreEmpresa'] . "_" . $fechaHora . ".pdf";

        // * Salida de un archivo PDF directamente a la pestaña del navegador
        $this->mpdf->Output("pdfs/" . $nombrePdf);





        // ! SENDGRID

        // * Crea objeto de SendGrid y le envía el API Key como parametro al constructor
        $sendgrid = new \SendGrid("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");

        // * Crea objeto de Mail()
        $this->email = new \SendGrid\Mail\Mail();
        // * Se asignanr parametros a las funciones de Mail()
    	$this->email->setFrom("consola@somosproper.com", "Proper Shop");
        $this->email->setSubject("Reporte de cierre " . $params['nombreEmpresa'] . "_" . $fechaHora);
        $this->email->addTo($params['email'], $params['nombreEmpresa']);
        $this->email->addContent(
            "text/plain",
            "Reporte"
        );

        // * Codificacion de archivo generado en carpeta 'pdfs/.$nombrePdf'
        $file_encoded = base64_encode(file_get_contents("pdfs/" . $nombrePdf));

        // * Se adjunta el pdf creado al email
        $this->email->addAttachment(
            $file_encoded,
            "application/pdf",
            $nombrePdf,
            "attachment"
        );

        // *  Intento de envío
        try {
            $response = $sendgrid->send($this->email);
            print 'Email sent successfuly' . "\n";
            print 'Status Code: ' . $response->statusCode() . "\n";
        } catch (Exception $e) {
            echo 'Caught exception: ' .  $e->getMessage() . "\n";
        }
    }

    // ! SOLO DE PRUEBA Subrutina para generar el reporte con los datos del $response[] 
    public function generarReporteCierrePDF2()
    {

        // * Establece la zona horaria por defecto.
        date_default_timezone_set('America/Guatemala');

        // * Creación de fecha y hora
        $fechaHora = date("Y-m-d_H-i-s");

        $htm = "
        <!DOCTYPE html>
        <html lang='es'>
            <head>
                <meta charset='UTF-8' />
                <meta name='viewport' content='width=device-width, initial-scale=1.0' />
                <title>REPORTE_CIERRE_" . $fechaHora . ".pdf</title>
            </head>
        
            <body>
                <div>
                    <div>
                        <h5>CORTE CAJA</h5>
                        <h6>Usuario:</h6>
                        <p>APERTURA:</p>
                        <p>CIERRE:</p>
                        <h6>VALES:</h6>
                        <h6>FONDO CAJA:</h6>
                        <h6>VISA:</h6>
                        <h6>CREDOMATIC:</h6>
                        <h6>EFECTIVO:</h6>
                        <h5>VENTA NETA:</h5>
                    </div>
                </div>
                <div>
                    <div>
                        <p>- DETALLE POR PRODUCTO -</p>
                        <p></p>
                        <table>
                            <thead>
                                <tr>
                                    <th>Descripcion</th>
                                    <th>Cant.</th>
                                    <th>Total</th>
                                </tr>
                            </thead>
        
                            <tbody>
                                <tr>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </body>
        </html>
        ";

        // ! Crea una instancia de la clase Mpdf:
        $this->mpdf = new \Mpdf\Mpdf();

        // * Renderiza el HTML
        $this->mpdf->WriteHTML($htm);

        // * Salida de un archivo PDF directamente a la pestaña del navegador
        $this->mpdf->Output('filename.pdf', \Mpdf\Output\Destination::FILE);
        return $this->mpdf;
    }


    // sendgrid api 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
}
